// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Тут будет связь с внешним миром

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <OneWire.h>
#include <EEPROM.h>

#include "configuration.h"
#include "declarations.h"

#if USE_WiFi  == 1
void SendESP8266()
{
  switch (flWiFiState)
  {
    case 0:  // Состояние не запущено
      break;
    case 2: // С состояний, соответсвующих отправке активируем wi-fi соединение
    case 14:
      flWiFiState = 158;
      break;
    case 40: // Состояние 40 - передаем информацию
      flWiFiState = 158;
      flNeedCall = 3; // ставим признак что соединились
    case 99:
      if (timeWaitWiFi == 0) flWiFiState = 98;
      break;
    case 150:
      timeWaitWiFi = 2;  // Было 10
      Serial2.println("AT+CWMODE_CUR=1");
      flWiFiState = 151;
    case 151:
      if (timeWaitWiFi == 0) flWiFiState = 150;
      break;
    case 152:
      // Отключаемся от сети
      timeWaitWiFi = 2;
      Serial2.println("AT+CWQAP");
      flWiFiState = 153;
    case 153:
      if (timeWaitWiFi == 0) flWiFiState = 152;
      break;
    case 154:
      // Проверка подключения
      timeWaitWiFi = 2;
      Serial2.println("AT+CIFSR");
      flWiFiState = 155;
    case 155:
      if (timeWaitWiFi == 0) flWiFiState = 154;
      break;
    case 168: // Промежуточное состояние - к серверу подключены, идет ожидание OK
      if (timeWaitWiFi == 0) flWiFiState = 154;
      break;
    case 158:
      timeWaitWiFi = 2;
      // проверка соединения с сервером.
      Serial2.println("AT+CIPSTATUS");
      flWiFiState = 159;
    case 159:
      if (timeWaitWiFi == 0) flWiFiState = 158;
      break;
    case 167: // Промежуточное состояние - к серверу подключены, идет ожидание OK
      if (timeWaitWiFi == 0) flWiFiState = 158;
      break;
    case 162:
      // Отправка
      timeWaitWiFi = 2;
      Serial2.println("AT+CIPSENDBUF=56");
      flWiFiState = 163;
    case 163:
      if (timeWaitWiFi == 0) flWiFiState = 162;
      break;
    case 164:
      timeWaitWiFi = 2;
      DisplayData();
      break;
    case 165:
      if (timeWaitWiFi == 0) flWiFiState = 158;
      // Сообщение отправлено
      break;
    case 180: // Закрываем TCP-UDP соединение и завершаем сеанс
      timeWaitWiFi = 2;
      Serial2.println("AT+CIPCLOSE");
      flWiFiState = 181;
    case 181:
      flWiFiState = 0; // Ничего не делаем, ждем.
      break;
    default:
      // Если состояние неизвестно, то переходим на инициализацию.
      flWiFiState = 98;
      break;
  }

}
#endif

void ClearBuffer()
{
  while (Serial2.available() > 0) Serial2.read();
  pos_rx_buffer = 0;
  my_rx_buffer[pos_rx_buffer] = 0;
}

void GetState()
{
  int tic1;
  unsigned char hour, minute;
  hour = Seconds / 3600;
  tic1 = Seconds % 3600;
  minute = tic1 / 60;
  sprintf(my_tx_buffer, ("%02u:%02u I=%3u S=%3u T=%3u,%3u,%3u V=%4u,%4u OFF=%1i,%4uW,U=%3u,%3imm"), hour, minute, IspReg, StateMachine, temps[0], temps[1], temps[2], U_VODA, U_UROVEN, (int) flAllOff, UstPower, MaxVoltsOut, U_MPX5010);

}

